﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.3
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: true
	#IncludeTitle: false
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Private rp As RuntimePermissions
	Private lblBT As Label
	Private btnBTConnect As Button
End Sub

'Starts the BTSTART activity and starts the Bluetooth listen for 
'-----------------------------------------------------------------
Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("BTControl")
	btnBTConnect.Visible=True
	lblBT.Visible=False
End Sub


Sub Activity_Resume
	btnBTConnect.Visible=True
	lblBT.Visible=False
End Sub

' Gains Permission and then searches for devices
Sub BTPermissions
	Log("Waiting for permissions")
	rp.CheckAndRequest(rp.PERMISSION_ACCESS_COARSE_LOCATION)
	Wait For Activity_PermissionResult (Permission As String, Result As Boolean)
	If Result = False Then
		ToastMessageShow("No permission...", False)
		Return
	End If
	Log("Permission Granted  "&Result)

	Dim success As Boolean = Starter.Manager.SearchForDevices         ' finds devices
	Log ("BT Found Devices " & success)
	If success = False Then
		ToastMessageShow("Error starting discovery process.", True)
	Else
		ProgressDialogShow2("Searching for devices...", False)     ' Spinning search box
	End If
End Sub

'Actioned when the BT discovery process is finished.
'Tries to connect to device
Public Sub DiscoverFinished
	Log("Discovery Finished")
	ProgressDialogHide										' hides spinning search box
	If Starter.Manager.foundDevices.Size = 0 Then
		ToastMessageShow("No Bluetooth devices found.", True)
	Else
		Dim Count As Int = 0
		Dim Index As Int =0
		For Each nm As NameAndMac In Starter.Manager.foundDevices          'Searches names in found devices
			If nm.Name = Starter.BTName  Then 
				Index = Count
			End If
			Count = Count+1
		Next
		Dim device As NameAndMac = Starter.Manager.foundDevices.Get(Index)
		Log(device.Name)
		If device.Name= Starter.BTName Then                                ' checks as count could be zero
			Starter.Manager.ConnectTo(device)
			ProgressDialogShow2($"Trying to connect to Spoke Clock"$, False)
		Else
			ProgressDialogShow2("Spoke Clock cannot be connected", False)
			Sleep(2000)
		End If
	End If
End Sub


'Actioned after bluetooth connects
Public Sub AfterConnect (Success As Boolean)
	Log("Serial Connected " & Success)
	Sleep(1000)
	If Success = False Then
		Sleep(2000)
		BTConnectMessage("CANNOT CONNECT TO CLOCK")
	Else
		BTConnectMessage("BLUETOOTH CONNECTION SUCCESSFUL")
		ProgressDialogHide
		CallSub(Starter,"BTConnected")
	End If
End Sub

Sub btnBTConnect_Click
	If Starter.BTConnectionState=False Then
		BTPermissions
	Else
		Starter.Manager.Disconnect
	End If
End Sub


Sub BTConnectMessage(Message As String)
	lblBT.Visible=True
	btnBTConnect.Visible=False
	lblBT.Text=Message
	lblBT.Color=Colors.Black
End Sub

