﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8
@EndOfDesignText@
Sub Class_Globals
	Private admin As BluetoothAdmin
	Public foundDevices As List
	Type NameAndMac (Name As String, Mac As String)
	Public BluetoothState As Boolean
End Sub

Public Sub Initialize
	admin.Initialize("admin")
	If admin.IsEnabled = False Then
		If admin.Enable = False Then
			ToastMessageShow("Error enabling Bluetooth adapter.", True)
		Else
			ToastMessageShow("Enabling Bluetooth adapter...", False)
		End If
	Else
		BluetoothState = True
	End If
End Sub

Private Sub Admin_StateChanged (NewState As Int, OldState As Int)
	Log("Admin State changed: " & NewState)
	BluetoothState = NewState = admin.STATE_ON
End Sub


Public Sub ConnectTo (Device As NameAndMac)
	Log("BT Manager Connect to Device " & Device.Name)
	Starter.serial.Connect(Device.Mac)
End Sub

Private Sub Serial_Connected (Success As Boolean)
	Log("BT Manager Serial connected: " & Success)
	CallSub2(BTStart, "AfterConnect", Success)
End Sub


Public Sub Disconnect
	If Starter.BTastream.IsInitialized Then Starter.BTastream.Close
	Starter.serial.Disconnect
	
End Sub

Public Sub SearchForDevices As Boolean
	Log("BT Manager Search for devices")
	foundDevices.Initialize
	Log("Found Devices Initialize")
	Return admin.StartDiscovery
End Sub

Private Sub Admin_DiscoveryFinished
	Log("BT Manager Discovery Finish")
	CallSub(BTStart, "DiscoverFinished")
End Sub

Private Sub Admin_DeviceFound (Name As String, MacAddress As String)
	Log("BT Manager Device Found  "& Name & ":" & MacAddress)
	Dim nm As NameAndMac
	nm.Name = Name
	nm.Mac = MacAddress
	foundDevices.Add(nm)
	If Name = Starter.BTName Then           
		admin.CancelDiscovery
	End If
End Sub

Public Sub ListenForConnections
	'this intent makes the device discoverable for 300 seconds.
	Log("BT Manager Listen for connections")
	Dim i As Intent
	i.Initialize("android.bluetooth.adapter.action.REQUEST_DISCOVERABLE", "")
	i.PutExtra("android.bluetooth.adapter.extra.DISCOVERABLE_DURATION", 300)
	StartActivity(i)
	Starter.serial.Listen
End Sub
