﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Public serial As Serial
	Public BTastream As AsyncStreams
	Public Manager As BluetoothManager
	Public BTName As String = "SpokeClock"
	Public BTConnectionState As Boolean=False
	Dim ClockTimer As Timer
	
	' Array
	Public ser As B4RSerializator
	Public SendArray(8) As Byte                   	'Sends via B4R Serial
	
	' Returned to APP
	Public HourTen As Int						'Clock Times in HRC
	Public HourUnit As Int
	Public MinTen As Int
	Public MinUnit As Int

End Sub

Sub Service_Create
	ser.Initialize
	ClockTimer.Initialize("ClockTimer",500)             ' Every 500 mseconds
	ClockTimer.Enabled=True
	serial.Initialize("serial")
	Manager.Initialize
End Sub


'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

'Called from successful connection on Bluetooth
Sub BTConnected
	Log("BT Serial Connected")
	If BTastream.IsInitialized Then BTastream.Close
	BTastream.InitializePrefix(serial.InputStream,True, serial.OutputStream, "BTastream")
	BTConnectionState=True
	Sleep(500)
	StartActivity("TimeControl")
End Sub

Sub ClearSendArray
	For i = 0 To SendArray.Length-1
		SendArray(i) = 0
	Next
End Sub
	'COMMUNICATION STRUCTURE TO APP
'=============================================================================================================	
'Data(0) = key	
'				Time		Control							MotorStatus				Limits					Alarms	
'-----------------------------------------------------------------------------------------------------
'Data (0)		1				2							3						4						5
'Data (1)		HourTen			
'Data (2)		HourUnit									
'Data (3)		MinTen																
'Data (4)		MinUnit															
'Date (5)																			PosnHourTen
'Data (6)																			PosnHourUnit
'Data (7)																			PosnMinTen
'Data (8)																			PosMinUnit
	
' Recieves from PLay
Sub BTastream_NewData (Buffer() As Byte)
	Log(Buffer.Length)
	Log("From PLAY " & Buffer(0) &" "& Buffer(1) &" "& Buffer(2) &" "& Buffer(3) &" "& Buffer(4) &" "& Buffer(5) &" "& Buffer(6) &" "& Buffer(7) &" "& Buffer(8))
	Select Buffer(0)
		Case 1
			HourTen=Bit.And(Buffer(1), 0xFF)					        'Converts unsigned byte to signed(essentially integer)
			HourUnit=Bit.And(Buffer(2),0xff)
			MinTen=Bit.And(Buffer(3),0xff)
			MinUnit=Bit.And(Buffer(4),0xff)
	End Select
	Log(HourTen)
	Log(HourUnit)
	Log(MinTen)
	Log(MinUnit)
End Sub

 'Sends information To ESP32 in HRC
Sub SendToHRC
	If BTConnectionState Then
		BTastream.write(ser.ConvertArrayToBytes(Array(SendArray(0),SendArray(1),SendArray(2),SendArray(3),SendArray(4),SendArray(5),SendArray(6),SendArray(7))))
	End If
End Sub

Sub BTastream_Error
	BTConnectionState=False
End Sub

Sub astream_Terminated
End Sub

'Updates the time on the Edit Page
Sub ClockTimer_Tick
	'Log(BTConnectionState)
	CallSub(TimeControl,"UpdateActualTime")
	CallSub(TimeControl,"UpdateHRCTime")
End Sub

